test-lib: tests skipped by GIT_SKIP_TESTS say so
[git/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
85176d72
FC
29else
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
33fi
34if test -z "$TEST_OUTPUT_DIRECTORY"
35then
36 # Similarly, override this to store the test-results subdir
37 # elsewhere
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
39fi
40GIT_BUILD_DIR="$TEST_DIRECTORY"/..
41
2006f0ad
RR
42################################################################
43# It appears that people try to run tests without building...
44"$GIT_BUILD_DIR/git" >/dev/null
45if test $? != 1
46then
47 echo >&2 'error: you do not seem to have built git yet.'
48 exit 1
49fi
50
3c8f12c9
JH
51. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52export PERL_PATH SHELL_PATH
53
4cde519f
RR
54# if --tee was passed, write the output not only to the terminal, but
55# additionally to the file test-results/$BASENAME.out, too.
56case "$GIT_TEST_TEE_STARTED, $* " in
57done,*)
58 # do not redirect again
59 ;;
60*' --tee '*|*' --va'*)
2d14e13c
JK
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
4cde519f
RR
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
66 exit
67 ;;
68esac
69
e1970ce4
JH
70# For repeatability, reset the environment to known value.
71LANG=C
899460f3 72LC_ALL=C
d9bdd39e 73PAGER=cat
e1970ce4 74TZ=UTC
c2116a17
JH
75TERM=dumb
76export LANG LC_ALL PAGER TERM TZ
8ff99e74 77EDITOR=:
661bfd13
SL
78# A call to "unset" with no arguments causes at least Solaris 10
79# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80# deriving from the command substitution clustered with the other
81# ones.
3c8f12c9 82unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 83 my @env = keys %ENV;
730477f1
JL
84 my $ok = join("|", qw(
85 TRACE
86 DEBUG
87 USE_LOOKUP
88 TEST
89 .*_TEST
90 PROVE
91 VALGRIND
ac001282 92 UNZIP
edb54081 93 PERF_
730477f1
JL
94 ));
95 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
96 print join("\n", @vars);
97')
5adf84eb 98unset XDG_CONFIG_HOME
8bade1e1 99unset GITPERLLIB
29e55cd5
JH
100GIT_AUTHOR_EMAIL=author@example.com
101GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
102GIT_COMMITTER_EMAIL=committer@example.com
103GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 104GIT_MERGE_VERBOSITY=5
f8246281
JH
105GIT_MERGE_AUTOEDIT=no
106export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
107export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
108export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 109export EDITOR
e1970ce4 110
5d9fc888
TG
111if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
112then
113 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
114 export GIT_INDEX_VERSION
115fi
116
a731fa91
EP
117# Add libc MALLOC and MALLOC_PERTURB test
118# only if we are not executing the test with valgrind
1b3185fc 119if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 120 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
121then
122 setup_malloc_check () {
123 : nothing
124 }
125 teardown_malloc_check () {
126 : nothing
127 }
128else
129 setup_malloc_check () {
130 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
131 export MALLOC_CHECK_ MALLOC_PERTURB_
132 }
133 teardown_malloc_check () {
134 unset MALLOC_CHECK_ MALLOC_PERTURB_
135 }
136fi
a731fa91 137
886a3907
JH
138# Protect ourselves from common misconfiguration to export
139# CDPATH into the environment
140unset CDPATH
141
5565f47c 142unset GREP_OPTIONS
ac001282 143unset UNZIP
5565f47c 144
3d5c0cc9 145case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1461|2|true)
147 echo "* warning: Some tests will not work if GIT_TRACE" \
148 "is set as to trace on STDERR ! *"
149 echo "* warning: Please set GIT_TRACE to something" \
150 "other than 1, 2 or true ! *"
151 ;;
6ce4e61f
CC
152esac
153
cd3c095c
JH
154# Convenience
155#
156# A regexp to match 5 and 40 hexdigits
157_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
158_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
159
3749fde5
JH
160# Zero SHA-1
161_z40=0000000000000000000000000000000000000000
162
3f4ab627
JH
163# Line feed
164LF='
165'
166
342e9ef2
TR
167export _x05 _x40 _z40 LF
168
e1970ce4
JH
169# Each test should start with something like this, after copyright notices:
170#
171# test_description='Description of this test...
172# This test checks if command xyzzy does the right thing...
173# '
174# . ./test-lib.sh
c2116a17
JH
175[ "x$ORIGINAL_TERM" != "xdumb" ] && (
176 TERM=$ORIGINAL_TERM &&
177 export TERM &&
178 [ -t 1 ] &&
179 tput bold >/dev/null 2>&1 &&
180 tput setaf 1 >/dev/null 2>&1 &&
181 tput sgr0 >/dev/null 2>&1
182 ) &&
55db1df0 183 color=t
e1970ce4 184
e1970ce4
JH
185while test "$#" -ne 0
186do
187 case "$1" in
188 -d|--d|--de|--deb|--debu|--debug)
189 debug=t; shift ;;
886856ab
JH
190 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
191 immediate=t; shift ;;
5e2c08c6 192 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 193 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 194 -h|--h|--he|--hel|--help)
570f3226 195 help=t; shift ;;
e1970ce4
JH
196 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
197 verbose=t; shift ;;
ff09af3f
TR
198 --verbose-only=*)
199 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
200 shift ;;
1ece1274 201 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
202 # Ignore --quiet under a TAP::Harness. Saying how many tests
203 # passed without the ok/not ok details is always an error.
204 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
205 --with-dashes)
206 with_dashes=t; shift ;;
55db1df0 207 --no-color)
faa4bc35 208 color=; shift ;;
4e1be63c 209 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
210 valgrind=memcheck
211 shift ;;
212 --valgrind=*)
213 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
214 shift ;;
5dfc368f
TR
215 --valgrind-only=*)
216 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
217 shift ;;
44138559
JS
218 --tee)
219 shift ;; # was handled already
f423ef5f
JK
220 --root=*)
221 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
222 shift ;;
e1970ce4 223 *)
1f729dca 224 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
225 esac
226done
227
26a07309 228if test -n "$valgrind_only"
5dfc368f
TR
229then
230 test -z "$valgrind" && valgrind=memcheck
231 test -z "$verbose" && verbose_only="$valgrind_only"
232elif test -n "$valgrind"
233then
234 verbose=t
235fi
952af351 236
1c0cc756
RJ
237if test -n "$color"
238then
55db1df0 239 say_color () {
c2116a17
JH
240 (
241 TERM=$ORIGINAL_TERM
242 export TERM
55db1df0 243 case "$1" in
1c0cc756
RJ
244 error)
245 tput bold; tput setaf 1;; # bold red
246 skip)
b8fc855a 247 tput setaf 4;; # blue
e8e51955
AS
248 warn)
249 tput setaf 3;; # brown/yellow
1c0cc756 250 pass)
0a6d4751 251 tput setaf 2;; # green
1c0cc756 252 info)
0a6d4751 253 tput setaf 6;; # cyan
1c0cc756
RJ
254 *)
255 test -n "$quiet" && return;;
55db1df0
PH
256 esac
257 shift
5099b99d 258 printf "%s" "$*"
55db1df0 259 tput sgr0
b8eecafd 260 echo
c2116a17 261 )
55db1df0
PH
262 }
263else
264 say_color() {
1ece1274 265 test -z "$1" && test -n "$quiet" && return
55db1df0 266 shift
7bc0911d 267 printf "%s\n" "$*"
55db1df0
PH
268 }
269fi
270
271error () {
272 say_color error "error: $*"
6e7b5aaf 273 GIT_EXIT_OK=t
55db1df0
PH
274 exit 1
275}
276
277say () {
278 say_color info "$*"
279}
280
570f3226
MB
281test "${test_description}" != "" ||
282error "Test script did not set test_description."
283
284if test "$help" = "t"
285then
cb1aefda 286 printf '%s\n' "$test_description"
570f3226
MB
287 exit 0
288fi
289
4d9d62fa 290exec 5>&1
781f76b1 291exec 6<&0
e1970ce4
JH
292if test "$verbose" = "t"
293then
294 exec 4>&2 3>&1
295else
296 exec 4>/dev/null 3>/dev/null
297fi
298
299test_failure=0
300test_count=0
41ac414e
JH
301test_fixed=0
302test_broken=0
2d84e9fb 303test_success=0
e1970ce4 304
d998bd4a
ÆAB
305test_external_has_tap=0
306
faa4bc35 307die () {
6e7b5aaf
CB
308 code=$?
309 if test -n "$GIT_EXIT_OK"
310 then
311 exit $code
312 else
313 echo >&5 "FATAL: Unexpected exit with code $code"
314 exit 1
315 fi
faa4bc35
CB
316}
317
6e7b5aaf 318GIT_EXIT_OK=
35641310 319trap 'die' EXIT
41184273 320
12a29b1a
TR
321# The user-facing functions are loaded from a separate file so that
322# test_perf subshells can have them too
3c8f12c9 323. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 324
886856ab 325# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 326# the test_expect_* functions instead.
886856ab
JH
327
328test_ok_ () {
d5d9de1b 329 test_success=$(($test_success + 1))
633fe50a 330 say_color "" "ok $test_count - $@"
e1970ce4
JH
331}
332
886856ab 333test_failure_ () {
d5d9de1b 334 test_failure=$(($test_failure + 1))
633fe50a 335 say_color error "not ok $test_count - $1"
bf0dd8a8 336 shift
cb1aefda 337 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 338 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
339}
340
41ac414e 341test_known_broken_ok_ () {
41ac414e 342 test_fixed=$(($test_fixed+1))
633fe50a 343 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
344}
345
346test_known_broken_failure_ () {
41ac414e 347 test_broken=$(($test_broken+1))
633fe50a 348 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 349}
886856ab
JH
350
351test_debug () {
8e832ebc 352 test "$debug" = "" || eval "$1"
e1970ce4
JH
353}
354
e6a6ddc9
TR
355match_pattern_list () {
356 arg="$1"
357 shift
358 test -z "$*" && return 1
359 for pattern_
360 do
361 case "$arg" in
362 $pattern_)
363 return 0
364 esac
365 done
366 return 1
367}
368
ff09af3f
TR
369maybe_teardown_verbose () {
370 test -z "$verbose_only" && return
371 exec 4>/dev/null 3>/dev/null
372 verbose=
373}
374
375last_verbose=t
376maybe_setup_verbose () {
377 test -z "$verbose_only" && return
26a07309 378 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
379 then
380 exec 4>&2 3>&1
381 # Emit a delimiting blank line when going from
382 # non-verbose to verbose. Within verbose mode the
383 # delimiter is printed by test_expect_*. The choice
384 # of the initial $last_verbose is such that before
385 # test 1, we do not print it.
386 test -z "$last_verbose" && echo >&3 ""
387 verbose=t
388 else
389 exec 4>/dev/null 3>/dev/null
390 verbose=
391 fi
392 last_verbose=$verbose
393}
394
5dfc368f
TR
395maybe_teardown_valgrind () {
396 test -z "$GIT_VALGRIND" && return
397 GIT_VALGRIND_ENABLED=
398}
399
400maybe_setup_valgrind () {
401 test -z "$GIT_VALGRIND" && return
26a07309 402 if test -z "$valgrind_only"
5dfc368f
TR
403 then
404 GIT_VALGRIND_ENABLED=t
405 return
406 fi
407 GIT_VALGRIND_ENABLED=
408 if match_pattern_list $test_count $valgrind_only
409 then
410 GIT_VALGRIND_ENABLED=t
411 fi
412}
413
a7c58f28
JN
414test_eval_ () {
415 # This is a separate function because some tests use
416 # "return" to end a test_expect_success block early.
781f76b1 417 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
418}
419
4d9d62fa 420test_run_ () {
b6b0afdc 421 test_cleanup=:
b586744a 422 expecting_failure=$2
a57397b0 423 setup_malloc_check
a7c58f28 424 test_eval_ "$1"
b6b0afdc 425 eval_ret=$?
a57397b0 426 teardown_malloc_check
b586744a
JH
427
428 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
429 then
1b3185fc 430 setup_malloc_check
a7c58f28 431 test_eval_ "$test_cleanup"
1b3185fc 432 teardown_malloc_check
b586744a 433 fi
1c0cc756
RJ
434 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
435 then
57e1538a
ÆAB
436 echo ""
437 fi
aa0bcf96 438 return "$eval_ret"
4d9d62fa
PR
439}
440
ae75342c 441test_start_ () {
8586f98b 442 test_count=$(($test_count+1))
ff09af3f 443 maybe_setup_verbose
5dfc368f 444 maybe_setup_valgrind
ae75342c
TR
445}
446
447test_finish_ () {
448 echo >&3 ""
5dfc368f 449 maybe_teardown_valgrind
ff09af3f 450 maybe_teardown_verbose
ae75342c
TR
451}
452
453test_skip () {
04ece593 454 to_skip=
ef2ac68d 455 skipped_reason=
e6a6ddc9
TR
456 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
457 then
458 to_skip=t
ef2ac68d 459 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 460 fi
05236a5e
JN
461 if test -z "$to_skip" && test -n "$test_prereq" &&
462 ! test_have_prereq "$test_prereq"
a7bb3940
JS
463 then
464 to_skip=t
ef2ac68d 465
07431fc8 466 of_prereq=
05236a5e 467 if test "$missing_prereq" != "$test_prereq"
07431fc8 468 then
05236a5e 469 of_prereq=" of $test_prereq"
07431fc8 470 fi
ef2ac68d
IB
471 skipped_reason="missing $missing_prereq${of_prereq}"
472 fi
473 case "$to_skip" in
474 t)
633fe50a 475 say_color skip >&3 "skipping test: $@"
ef2ac68d 476 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
477 : true
478 ;;
479 *)
480 false
481 ;;
482 esac
483}
484
342e9ef2
TR
485# stub; perf-lib overrides it
486test_at_end_hook_ () {
487 :
488}
489
e1970ce4 490test_done () {
6e7b5aaf 491 GIT_EXIT_OK=t
2d84e9fb 492
1c0cc756
RJ
493 if test -z "$HARNESS_ACTIVE"
494 then
342e9ef2 495 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 496 mkdir -p "$test_results_dir"
dd78478f
FC
497 base=${0##*/}
498 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 499
c54e6be7
ML
500 cat >>"$test_results_path" <<-EOF
501 total $test_count
502 success $test_success
503 fixed $test_fixed
504 broken $test_broken
505 failed $test_failure
506
507 EOF
8ef1abe5 508 fi
41ac414e
JH
509
510 if test "$test_fixed" != 0
511 then
633fe50a 512 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
513 fi
514 if test "$test_broken" != 0
515 then
633fe50a 516 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
517 fi
518 if test "$test_broken" != 0 || test "$test_fixed" != 0
519 then
520 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
521 msg="remaining $test_remaining test(s)"
11d54b8b 522 else
b73d9a23 523 test_remaining=$test_count
11d54b8b 524 msg="$test_count test(s)"
41ac414e 525 fi
e1970ce4 526 case "$test_failure" in
10b94e28 527 0)
5099b99d 528 # Maybe print SKIP message
bf4b7219
RJ
529 if test -n "$skip_all" && test $test_count -gt 0
530 then
531 error "Can't use skip_all after running some tests"
532 fi
5099b99d
ÆAB
533 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
534
1c0cc756
RJ
535 if test $test_external_has_tap -eq 0
536 then
b73d9a23 537 if test $test_remaining -gt 0
d87bd7c1 538 then
633fe50a 539 say_color pass "# passed all $msg"
d87bd7c1 540 fi
633fe50a 541 say "1..$test_count$skip_all"
d998bd4a 542 fi
abc5d372
JS
543
544 test -d "$remove_trash" &&
545 cd "$(dirname "$remove_trash")" &&
546 rm -rf "$(basename "$remove_trash")"
547
342e9ef2
TR
548 test_at_end_hook_
549
e1970ce4
JH
550 exit 0 ;;
551
552 *)
1c0cc756
RJ
553 if test $test_external_has_tap -eq 0
554 then
633fe50a
TR
555 say_color error "# failed $test_failure among $msg"
556 say "1..$test_count"
d998bd4a 557 fi
5099b99d 558
e1970ce4
JH
559 exit 1 ;;
560
561 esac
562}
563
e4597aae 564if test -n "$valgrind"
4e1be63c 565then
4e1be63c
JS
566 make_symlink () {
567 test -h "$2" &&
568 test "$1" = "$(readlink "$2")" || {
569 # be super paranoid
570 if mkdir "$2".lock
571 then
572 rm -f "$2" &&
573 ln -s "$1" "$2" &&
574 rm -r "$2".lock
575 else
576 while test -d "$2".lock
577 do
578 say "Waiting for lock on $2."
579 sleep 1
580 done
581 fi
582 }
583 }
584
585 make_valgrind_symlink () {
36bfb0e5 586 # handle only executables, unless they are shell libraries that
11d62145 587 # need to be in the exec-path.
36bfb0e5 588 test -x "$1" ||
11d62145 589 test "# " = "$(head -c 2 <"$1")" ||
36bfb0e5 590 return;
4e1be63c
JS
591
592 base=$(basename "$1")
6cec5c68 593 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
594 # do not override scripts
595 if test -x "$symlink_target" &&
596 test ! -d "$symlink_target" &&
597 test "#!" != "$(head -c 2 < "$symlink_target")"
598 then
599 symlink_target=../valgrind.sh
600 fi
efd92ffd
JS
601 case "$base" in
602 *.sh|*.perl)
603 symlink_target=../unprocessed-script
604 esac
4e1be63c
JS
605 # create the link, or replace it if it is out of date
606 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
607 }
608
26a07309
TR
609 # override all git executables in TEST_DIRECTORY/..
610 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
611 mkdir -p "$GIT_VALGRIND"/bin
612 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
613 do
614 make_valgrind_symlink $file
615 done
616 # special-case the mergetools loadables
617 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
618 OLDIFS=$IFS
619 IFS=:
620 for path in $PATH
621 do
622 ls "$path"/git-* 2> /dev/null |
623 while read file
ad0e6233 624 do
26a07309 625 make_valgrind_symlink "$file"
ad0e6233 626 done
26a07309
TR
627 done
628 IFS=$OLDIFS
4e1be63c
JS
629 PATH=$GIT_VALGRIND/bin:$PATH
630 GIT_EXEC_PATH=$GIT_VALGRIND/bin
631 export GIT_VALGRIND
952af351
TR
632 GIT_VALGRIND_MODE="$valgrind"
633 export GIT_VALGRIND_MODE
5dfc368f 634 GIT_VALGRIND_ENABLED=t
26a07309 635 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 636 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
637elif test -n "$GIT_TEST_INSTALLED"
638then
e4597aae
MO
639 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
640 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 641 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
642 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
643else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 644 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
645 if ! test -x "$git_bin_dir/git"
646 then
647 if test -z "$with_dashes"
648 then
e4597aae
MO
649 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
650 fi
651 with_dashes=t
652 fi
653 PATH="$git_bin_dir:$PATH"
6cec5c68 654 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
655 if test -n "$with_dashes"
656 then
6cec5c68 657 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 658 fi
4e1be63c 659fi
6cec5c68 660GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 661GIT_CONFIG_NOSYSTEM=1
3c995beb 662GIT_ATTR_NOSYSTEM=1
8f323c00 663export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 664
5e87eae9
JH
665if test -z "$GIT_TEST_CMP"
666then
667 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
668 then
669 GIT_TEST_CMP="$DIFF -c"
670 else
671 GIT_TEST_CMP="$DIFF -u"
672 fi
673fi
674
6cec5c68 675GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 676export GITPERLLIB
6cec5c68 677test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
678 error "You haven't built things yet, have you?"
679}
e1970ce4 680
1c0cc756
RJ
681if ! test -x "$GIT_BUILD_DIR"/test-chmtime
682then
56cf9806
EW
683 echo >&2 'You need to build test-chmtime:'
684 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
685 exit 1
686fi
687
e1970ce4 688# Test repository
002d4ce8
JK
689TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
690test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
691case "$TRASH_DIRECTORY" in
692/*) ;; # absolute path is good
693 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 694esac
91c8b825 695test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 696rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 697 GIT_EXIT_OK=t
8d14ac94
JH
698 echo >&5 "FATAL: Cannot prepare test area"
699 exit 1
700}
701
90cff968
AR
702HOME="$TRASH_DIRECTORY"
703export HOME
704
1c0cc756
RJ
705if test -z "$TEST_NO_CREATE_REPO"
706then
38b074de 707 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 708else
38b074de 709 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 710fi
1bd9c648
LW
711# Use -P to resolve symlinks in our working directory so that the cwd
712# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 713cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 714
d5d9de1b
JS
715this_test=${0##*/}
716this_test=${this_test%%-*}
e6a6ddc9
TR
717if match_pattern_list "$this_test" $GIT_SKIP_TESTS
718then
719 say_color info >&3 "skipping test $this_test altogether"
720 skip_all="skip all tests in $this_test"
721 test_done
722fi
f17e9fbb 723
8648732e
BC
724# Provide an implementation of the 'yes' utility
725yes () {
726 if test $# = 0
727 then
728 y=y
729 else
730 y="$*"
731 fi
732
733 while echo "$y"
734 do
735 :
736 done
737}
738
f17e9fbb
JS
739# Fix some commands on Windows
740case $(uname -s) in
741*MINGW*)
742 # Windows has its own (incompatible) sort and find
743 sort () {
744 /usr/bin/sort "$@"
745 }
746 find () {
747 /usr/bin/find "$@"
748 }
5397ea31
JS
749 sum () {
750 md5sum "$@"
751 }
4114156a
JS
752 # git sees Windows-style pwd
753 pwd () {
754 builtin pwd -W
755 }
ee9fb68c 756 # no POSIX permissions
6fd1106a 757 # backslashes in pathspec are converted to '/'
fb9a2bea 758 # exec does not inherit the PID
a94114ad 759 test_set_prereq MINGW
cfa96496 760 test_set_prereq NOT_CYGWIN
a31d0665 761 test_set_prereq SED_STRIPS_CR
97669eed 762 test_set_prereq GREP_STRIPS_CR
4d715ac0 763 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
764 ;;
765*CYGWIN*)
766 test_set_prereq POSIXPERM
a31d0665
RJ
767 test_set_prereq EXECKEEPSPID
768 test_set_prereq NOT_MINGW
cfa96496 769 test_set_prereq CYGWIN
a31d0665 770 test_set_prereq SED_STRIPS_CR
97669eed 771 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
772 ;;
773*)
774 test_set_prereq POSIXPERM
6fd1106a 775 test_set_prereq BSLASHPSPEC
fb9a2bea 776 test_set_prereq EXECKEEPSPID
3ba9ba8f 777 test_set_prereq NOT_MINGW
cfa96496 778 test_set_prereq NOT_CYGWIN
f17e9fbb
JS
779 ;;
780esac
704a3143 781
b082687c 782( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 783test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 784test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 785test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 786test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 787
bb946bba 788# Can we rely on git's output in the C locale?
30955229
JN
789if test -n "$GETTEXT_POISON"
790then
791 GIT_GETTEXT_POISON=YesPlease
792 export GIT_GETTEXT_POISON
5e9637c6 793 test_set_prereq GETTEXT_POISON
30955229
JN
794else
795 test_set_prereq C_LOCALE_OUTPUT
796fi
bb946bba 797
cabdee2c
JH
798# Use this instead of test_cmp to compare files that contain expected and
799# actual output from git commands that can be translated. When running
800# under GETTEXT_POISON this pretends that the command produced expected
801# results.
802test_i18ncmp () {
803 test -n "$GETTEXT_POISON" || test_cmp "$@"
804}
805
127df8c6
JH
806# Use this instead of "grep expected-string actual" to see if the
807# output from a git command that can be translated either contains an
808# expected string, or does not contain an unwanted one. When running
809# under GETTEXT_POISON this pretends that the command produced expected
810# results.
811test_i18ngrep () {
812 if test -n "$GETTEXT_POISON"
813 then
814 : # pretend success
815 elif test "x!" = "x$1"
816 then
817 shift
818 ! grep "$@"
819 else
820 grep "$@"
821 fi
822}
823
20073274
AS
824test_lazy_prereq PIPE '
825 # test whether the filesystem supports FIFOs
9443605b
ML
826 case $(uname -s) in
827 CYGWIN*)
828 false
829 ;;
830 *)
831 rm -f testfifo && mkfifo testfifo
832 ;;
833 esac
20073274
AS
834'
835
04083f27
JH
836test_lazy_prereq SYMLINKS '
837 # test whether the filesystem supports symbolic links
838 ln -s x y && test -h y
839'
c91cfd19 840
b018c735
JN
841test_lazy_prereq FILEMODE '
842 test "$(git config --bool core.filemode)" = true
843'
844
ac39aa61
MG
845test_lazy_prereq CASE_INSENSITIVE_FS '
846 echo good >CamelCase &&
847 echo bad >camelcase &&
848 test "$(cat CamelCase)" != good
849'
850
5b0b5dd4
MG
851test_lazy_prereq UTF8_NFD_TO_NFC '
852 # check whether FS converts nfd unicode to nfc
853 auml=$(printf "\303\244")
854 aumlcdiar=$(printf "\141\314\210")
855 >"$auml" &&
856 case "$(echo *)" in
857 "$aumlcdiar")
858 true ;;
859 *)
860 false ;;
861 esac
862'
863
09feffb6
JK
864test_lazy_prereq AUTOIDENT '
865 sane_unset GIT_AUTHOR_NAME &&
866 sane_unset GIT_AUTHOR_EMAIL &&
867 git var GIT_AUTHOR_IDENT
868'
869
c91cfd19
ÆAB
870# When the tests are run as root, permission tests will report that
871# things are writable when they shouldn't be.
872test -w / || test_set_prereq SANITY
f838ce58
JK
873
874GIT_UNZIP=${GIT_UNZIP:-unzip}
875test_lazy_prereq UNZIP '
876 "$GIT_UNZIP" -v
877 test $? -ne 127
878'